/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

/**
 * @class AS.ARC.apps.upnpServer.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */

Ext.define('AS.ARC.apps.upnpServer.core.changeInfo', {
    extend: 'Ext.container.Container',

    alias: ['widget.asupnpServerChangeInfo'],

    layout: 'hbox',

    width: '100%',

	padding: '0 0 0 20',

    style: 'opacity:0;',

    imgUrl: 'resources/images/icons/',

    fadeOutId: '',

    applyChanged: function () {
        var me = this,
            ctIems = me.items;

        ctIems.get('icon').setSrc(me.imgUrl + 'ok.png');
        ctIems.get('message').setText(_S('COMMON', 'APPLY_CHANGE'));
        ctIems.get('message').el.dom.setStyle('font-size: 12px; color: #008000;');
        me.doDisplay();
    },

    applyNotChanged: function () {
        var me = this,
            ctIems = me.items;

        ctIems.get('icon').setSrc(me.imgUrl + 'warning2.png');
        ctIems.get('message').setText(_S('COMMON', 'SETTING_NO_CHANGE'));
        ctIems.get('message').el.dom.setStyle('font-size: 12px; color: #cc6633;');

        me.doDisplay();
    },

    resetDisplay: function () {
        var me = this;
        clearTimeout(me.fadeOutId);
        me.el.stopAnimation();
        me.el.dom.style.opacity = 0;
    },

    doDisplay: function () {
        var me = this;
        clearTimeout(me.fadeOutId);
        me.el.stopAnimation();
        me.el.fadeIn();
        me.fadeOutId = Ext.defer(function () {
            if (me.el) {
                me.el.fadeOut({duration: 3000});
            }
        }, 5000);
    },

    initComponent: function () {
        var me = this;
       
        Ext.apply(me, {
            items: [{
                xtype: 'image',
                itemId: 'icon',
                width: 16,   
                height: 16,
                src: me.imgUrl + 'warning2.png'
            }, {
                xtype: 'label',
				margin: '0 2',
                itemId: 'message',
                text: _S('COMMON', 'SETTING_NO_CHANGE'),
                fieldStyle: 'color:#cc6633;'
            }]
        });
        me.callParent(arguments);
    },

    beforeDestroy: function () {
        var me = this;
        me.callParent(arguments);
    }
});


Ext.ns('AS.ARC.upnpServer');
AS.ARC.upnpServer.pathtotal = '';
AS.ARC.upnpServer.pathdata = '';
AS.ARC.upnpServer.upnp_path = '';
AS.ARC.upnpServer.upnp_newpath='';
Ext.define('AS.ARC.apps.upnpServer.core', {
	extend: 'Ext.util.Observable',
	
	constructor: function (config) {
		Ext.apply(this, config);
		
		this.init(config);
	},
	
	upnpUrl: AS.ARC.util.getUserAppsPath() +  'upnp-server/' + 'upnpsrv.cgi',	
	MSG_TYPE_ERROR: 'error',
	MSG_TYPE_WARNING: 'warning',	
	
	GRIDPANEL_PAGESIZE: 4,
	
	constructor: function (config) {
		Ext.apply(this, config);

		this.callParent();
		this.init();
	},
	

	init: function () {
		page = this;
		GRIDPANEL_PAGESIZE = 4;
		upnpUrl = AS.ARC.util.getUserAppsPath() +  'upnp-server/' + 'upnpsrv.cgi',
		//Ext.form.VTypes.upnpNameMask = /[0-9a-zA-Z\/]/;
		Ext.form.VTypes.upnpNameText = '';
		Ext.form.VTypes.upnpName = function(v, f) {
			var MAX_LENGTH = 32;	
	
			if (typeof f.ajaxError === 'undefined') {
				f.ajaxError = true;
				f.ajaxErrorText = ''
			}
			if (v != '' && (f.workName != v)) {
				f.workName = v;
				if(AS.ARC.upnpServer.checkUpnpType =='create' ){
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(upnpUrl, {act: 'test_name'}),
						method: 'post',
						params: {name: v},
						success: function (json, opts) {
							if (v == f.workName) {
								f.clearInvalid();
								f.ajaxError = false;
								f.ajaxErrorText = '';
								var nameExist = f.ownerCt.items.get('upnp_name').ajaxError;
							}
						},
						failure: function (json, opts) {
							if (f.workName == v) {
								f.ajaxError = true;
								//footerBar.next.disable();
								if (json.error_code == '5008') {
									f.ajaxErrorText = _S('UPNP', 'HN00021');
								}else if(json.error_code == '5019'){
									f.ajaxErrorText = _S('UPNP', 'HN00022');
								} else {
									f.ajaxErrorText = 'error_code: ' + json.error_code;
								}
								f.markInvalid(f.ajaxErrorText);
							}
						}
					});
				}else{
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(upnpUrl, {act: 'test_name'}),
						method: 'post',
						params: {name: v, old_name: f.originalValue},
						success: function (json, opts) {
							if (v == f.workName) {
								f.clearInvalid();
								f.ajaxError = false;
								f.ajaxErrorText = '';
							}
						},
						failure: function (json, opts) {
							if (f.workName == v) {
								f.ajaxError = true;
								if (json.error_code == '5008') {
									f.ajaxErrorText = _S('UPNP', 'HN00021');
								}else if(json.error_code == '5019'){
									f.ajaxErrorText = _S('UPNP', 'HN00022');
								} else {
									f.ajaxErrorText = 'error_code: ' + json.error_code;
								}
								f.markInvalid(f.ajaxErrorText);
							}
						}
					});
				}
			}
			if (f.ajaxError && f.ajaxErrorText != '' ) {
				Ext.form.VTypes.upnpNameText = f.ajaxErrorText;
				return false;
			}
			return true;
		};
		// upnp path
		//Ext.form.VTypes.upnpPathMask = /[0-9a-zA-Z \/\-\_]/;
		//Ext.form.VTypes.upnpPathMask = /[^,]/;
		Ext.form.VTypes.upnpPathText = '';
		Ext.form.VTypes.upnpPath = function(v, f) {
			var fBar = f.ownerCt.ownerCt;
			if (typeof f.ajaxError === 'undefined') {
				f.ajaxError = true;
				f.ajaxErrorText = ''
			}

			/*if (!AS.ARC.re.upnpPath.test(v)) { // check path format
				Ext.form.VTypes.upnpPathText = _S('UPNP', 'ERROR_SELECTED_SAME_SHARE_FOLDER');
				return false;
			} else */if (v != '' && (f.workName != v)) {
				f.workName = v;
				if(AS.ARC.upnpServer.checkUpnpType =='create' ){
					var urlOpts = {
						act: 'test_path'
					};
					upnpUrl = AS.ARC.util.getUserAppsPath() +  'upnp-server/' + 'upnpsrv.cgi',
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(upnpUrl, urlOpts),
						method: 'post',
						params: {path: f.volumePath},
						success: function (json, opts) {
							AS.ARC.upnpServer.pathdata = json.data;
							AS.ARC.upnpServer.pathtotal = json.total;
							if (v == f.workName) {
								f.clearInvalid();
								f.ajaxError = false;
								f.ajaxErrorText = '';
								//return true;
							}
						},
						failure: function (json, opts) {
							if (f.workName == v) {
								f.ajaxError = true;
								if (json.error_code == '5008') {
									f.ajaxErrorText  = _S('UPNP','ERROR_SELECTED_SAME_SHARE_FOLDER') + json.overlap
								}else if(json.error_code == '5019' ){
									f.ajaxErrorText = _S('UPNP','ERROR_SELECTED_INCLUDED_SHARE_FOLDER') +json.overlap
								} else {
									f.ajaxErrorText = 'error_code: ' + json.error_code;
								}
								f.markInvalid(f.ajaxErrorText);
								//return false;
							}
						}
					});
					//return true;
				}else{
					var urlOpts = {
						act: 'test_path',
						path: f.volumePath,
						old_path: AS.ARC.upnpServer.upnp_path
					};
					upnpUrl = AS.ARC.util.getUserAppsPath() +  'upnp-server/' + 'upnpsrv.cgi',
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(upnpUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							if (v == f.workName) {
								f.clearInvalid();
								f.ajaxError = false;
								f.ajaxErrorText = '';
								AS.ARC.upnpServer.pathdata = json.data;
								AS.ARC.upnpServer.pathtotal = json.total;
							}
						},
						failure: function (json, opts) {
							if (f.workName == v) {
								f.ajaxError = true;
								//footerBar.next.disable();
								if (json.error_code == '5008') {
									f.ajaxErrorText = _S('UPNP','ERROR_SELECTED_SAME_SHARE_FOLDER')+ json.overlap
								}else if(json.error_code == '5019'){
									f.ajaxErrorText =  _S('UPNP','ERROR_SELECTED_INCLUDED_SHARE_FOLDER') +json.overlap
								} else {
									f.ajaxErrorText = 'error_code: ' + json.error_code;
								}
								f.markInvalid(f.ajaxErrorText);
							}
						}
					});
				}
			}
			if (f.ajaxError && f.ajaxErrorText != '' ) {
				Ext.form.VTypes.upnpPathText = f.ajaxErrorText;
				return false;
			}
			return true;
		};
		
		//================================== call CGI ===============================
		//show
			start = 0;
			limit = GRIDPANEL_PAGESIZE;
		var interfaceList = function (selectInterfaceText, selectInterface) {
			var interfaceListData = [];
			
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, {act: 'list_if'}),
				method: 'post',
				success: function (json, opts) {
					var data = json.data,
						dataLength = data.length,
						lostInt;
					
					// load the interface save settings and add into interfaceListData[] first, this settings maybe is disabled.
					if (typeof selectInterfaceText !== 'undefined' && typeof selectInterface !== 'undefined') {
						interfaceListData.push([selectInterfaceText, selectInterface]);
						lostInt = selectInterface;
					}
					
					// load the interface list and add into interfaceListData[] except already added item from settings.
					Ext.each(data, function (item) {
						
						// if (item.bind_interface == 0 && selectInterface !== 0) {
						// 	interfaceListData.push([_S('UPNP','LAN_1'), item.bind_interface]);
						// } else if (item.bind_interface == 1 && selectInterface !== 1) {
						// 	interfaceListData.push([_S('UPNP','LAN_2'), item.bind_interface]);
						// } else if (item.bind_interface == 2 && selectInterface !== 2) {
						// 	interfaceListData.push([_S('UPNP','LAGG'), item.bind_interface]);
						// } else if (item.bind_interface == 3 && selectInterface !== 3) {
						// 	interfaceListData.push([_S('UPNP','WIFI'), item.bind_interface]);
						// }
						
						if (item.bind_interface != selectInterface)
							interfaceListData.push([item.bind_interface, item.bind_interface]);
						
						// No lost interface when interface setting is exist in list. 
						if (item.bind_interface === selectInterface) {
							lostInt = '';
						} 
					});
					
					var interfaceListCombo = Ext.create('Ext.form.field.ComboBox', {	
						itemId: 'interfacelist',
						msgTarget: AS.ARC.config.msgTarget,
						fieldLabel: _S('UPNP','INTERFACE'),
						labelWidth: AS.ARC.config.layout.defaultLabelWidth,
						mode: 'local',
						editable: false,
						scope: this,
						lostInt: lostInt,
						store: new Ext.data.ArrayStore({
							fields: ['name', 'id'],
							data: interfaceListData
						}),
						displayField: 'name',
						valueField: 'id',
						width: 450,
						checkIntLost: function (record) {
							var me = this,
								newValue = me.getValue(),
								// get apply button
								advancedPanel = tabPanel.items.items[1],
								footPanel = advancedPanel.getDockedItems()[0];
								apply = footPanel.down('[itemId=apply]'); 
							
							if (me.lostInt === newValue) {
								me.markInvalid(Ext.String.format(_S('UPNP', 'LAN_LOST'), record.data.name));
								apply.setDisabled(true);
							} else {
								me.clearInvalid();
								apply.setDisabled(false);
							}
						},
						listeners: {
							afterrender: function (combo) {
								if (typeof selectInterface !== 'undefined') {
									combo.setValue(selectInterface);
									combo.checkIntLost(combo.getStore().data.getAt(0));
								}
								else {
									var recordSelected = combo.getStore().getAt(0);
									combo.setValue(recordSelected.data.id);
								}
							},
							select: function (combo, records) {
								combo.checkIntLost(records[0]);
							}
						}
					});
					if (typeof tabPanel.items.items[1].items.items[0].items.items[0] !== 'undefined') {
						tabPanel.items.items[1].items.items[0].items.items[0].destroy();
					}
					tabPanel.items.items[1].items.items[0].insert(0, interfaceListCombo);
					
					page.win.el.unmask();
				},
				failure: function (json, opts) {
					page.win.el.unmask();
					AS.ARC.util.showMsgWindow({
						
					}, json, page.win);
					
				}
			});
		
		};
		var tab_share_show = function(){
			var urlOpts = {
				act: 'show',								
				tab: 'share',
				start: start,
				limit: limit,
				overlap: ''
			};		
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					var generalItem = tabPanel.items.items[0].items.items[0].items;
					page.win.el.mask(_S('COMMON', 'LOADING'));
					sharingStore.load();
					if (json.status == 0) {
						generalItem.items[0].setValue(_S('UPNP', 'READY'));
					} else if (json.status == 1) {
						generalItem.items[0].setValue(_S('UPNP', 'SERVICE_DOWN'));
					} else if (json.status == 2) {
						generalItem.items[0].setValue(_S('UPNP', 'INVALID_BINDING_INTERFACE'));
					}
					
					generalItem.items[1].items.items[0].setValue(json.server_name);
					var id = generalItem.items[1].items.items[0].el.dom.down().next().down().id;
					Ext.fly(id).dom.setAttribute('data-qtip', json.server_name);                        
                    
                    if (json.scan_year === 0) {
						generalItem.items[2].items.items[0].setValue('--');
					} else {
                        var scandate,
                            dateConfig = {
                                dateFormat: json.date_format,
                                timeFormat: json.time_format,
                                year: json.scan_year,
                                month: json.scan_month,
                                day: json.scan_day,
                                hour: json.scan_hour,
                                minute: json.scan_minute,
                                second: json.scan_second
                            };
                        
                        scandate = page.getDisplayDateTime(dateConfig);
                        generalItem.items[2].items.items[0].setValue(scandate);
					}
					
					// if (json.interface == 0) {
					// 	generalItem.items[3].setValue(_S('UPNP', 'LAN_1'));
					// } else if (json.interface == 1) {
					// 	generalItem.items[3].setValue(_S('UPNP', 'LAN_2'));
					// } else if (json.interface == 2) {
					// 	generalItem.items[3].setValue(_S('UPNP', 'LAGG'));
					// } else if (json.interface == 3) {
					// 	generalItem.items[3].setValue(_S('UPNP', 'WIFI'));
					// }
					
					generalItem.items[3].setValue(json.bind_interface);
					
					setTimeout(function () {
						page.win.el.unmask();
					}, 500);
				},
				failure: function (json, opts) {
					page.win.el.unmask();
					AS.ARC.util.showMsgWindow({
						5401: _S('UPNP', 'ERROR_CONFIG_ERROR')
					}, json, tabPanel);
					
				}
			});
		
		};
		
		var tab_preference_show = function () {
			page.win.el.mask(_S('COMMON', 'LOADING'));
			var Flac = '0x00000001';
			var Vorbis='0x00000002';
			var urlOpts = {
				act: 'show',								
				tab: 'preference'
			};		
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					var transcode = json.transcode,
						flacValue = AS.ARC.util.xorfunction('AND', transcode,Flac),
						vorbisValue = AS.ARC.util.xorfunction('AND', transcode,Vorbis),
						showInterfaceText;
					
					if (flacValue != 0) {
						if (vorbisValue != 0) {
							//transcodingPanel.selModel.selectAll();
							pictureCheckbox.setValue(true);
							audioCheckbox.setValue(true);
						} else {
							//transcodingPanel.selModel.select(0);
							audioCheckbox.setValue(true);
							pictureCheckbox.setValue(false);
						}
					} else {
						if (vorbisValue != 0) {
							//transcodingPanel.selModel.select(1);
							audioCheckbox.setValue(false);
							pictureCheckbox.setValue(true);
						} else {
							//transcodingPanel.selModel.deselectAll();
							pictureCheckbox.setValue(false);
							audioCheckbox.setValue(false);
						}
					}
					
					// switch (json.interface) {
					// 	case 0:
					// 		showInterfaceText = _S('UPNP','LAN_1');
					// 		break;
					// 	case 1:
					// 		showInterfaceText = _S('UPNP','LAN_2');
					// 		break;
					// 	case 2:
					// 		showInterfaceText = _S('UPNP','LAGG');
					// 		break;
					// 	case 3:
					// 		showInterfaceText = _S('UPNP','WIFI');
					// 		break;
					// 	default:
					// 		break;
					// }
					
					
					interfaceList(json.bind_interface, json.bind_interface);
				},
				failure: function (json, opts) {
					//transcodingPanel.el.unmask();
					page.win.el.unmask();
					AS.ARC.util.showMsgWindow({
						5401:_S('UPNP','ERROR_CONFIG_ERROR')
					}, json, tabPanel);
				}
			});
			
		};
		//*************************** Store ***************************
		var urlOpts = {
			act: 'show',								
			tab:'share',
			overlap:''
		};		
		
		var sharingStore = Ext.create('Ext.data.JsonStore', {
			autoDestroy: true,
			fields: ['name', 'path'],
			pageSize: GRIDPANEL_PAGESIZE,
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				reader: {
					type: 'json',
					root: 'data',
					totalProperty: 'total'
				}
			},
			listeners:{
				load: function(){
					if(sharegridpanel.getSelectionModel().getSelection().length > 0){
						editBtn.enable();
						removeBtn.enable();
					}else{
						editBtn.disable();
						removeBtn.disable();
					}
				}
			}
		});
		//create cgi
		var overlap = '';
		var createfunction = function(){
			var urlOpts = {
				act: 'add',	
				name:upnpname.getValue(),
				path:volumepath,
				overlap: overlap
			};		
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					reloadflag = true;
					sharingStore.load();
					//page.win.el.mask(_S('COMMON', 'LOADING'));
					setTimeout(function () {
						page.win.el.unmask();
					}, 500);
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
						5008: _S('UPNP', 'ERROR_NAME_EXIST'),
						5031: _S('UPNP', 'ERROR_NAME_RESERVED'),
						5019: _S('UPNP', 'ERROR_CHANG_PATH'),
						5401: _S('UPNP', 'ERROR_UNABLE_ADD'),
						5051: _S('UPNP', 'ADD_EDIT_READ_ONLY')
					}, json, tabPanel);
				}
			});
			
		};
		
		
		//Edit cgi
		var createname;
		var path
		var getvalue = function(){
			var selected = sharegridpanel.getSelectionModel().getSelection();
			listname = selected[0].data.name;
			
			var urlOpts = {
				act: 'get',	
				name: listname,
				overlap:''
			};	
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					createname = json.name;
					AS.ARC.upnpServer.upnp_path = json.path;
					editname.setValue(json.name);
					temppath = json.path;
					temp = temppath.split("/");
					path = '';
					for(var i=2; i<temp.length;i++){
						string = '/' + temp[i] ;
						path = path +string;
					}
					editfolderLocation.setValue(path);
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
						5005: _S('UPNP', 'ERROR_MEDIA_SOURCE_NOTEXIST'),
						5008: _S('UPNP', 'ERROR_NAME_EXIST'),
						5031: _S('UPNP', 'ERROR_NAME_RESERVED'),
						5019: _S('UPNP', 'ERROR_CHANG_PATH'),
						5401: _S('UPNP','ERROR_UNABLE_OBTAIN')
					}, json, editwin);
				}
			});
			
		};
		//edit transcoding cgi
		var applyTranscode = function() {
			var advancedPanel = tabPanel.getActiveTab(),
                info = advancedPanel.getDockedItems()[0].down('[itemId=info]');

			page.win.el.mask(_S('COMMON', 'APPLYING'));
			var interfaceCombo = tabPanel.items.get('advance').items.items[0].items.items[0].store.data.items,
				datainCombo = false;
				
			Ext.each(interfaceCombo, function( items ) {
				if(tabPanel.items.items[1].items.items[0].items.items[0].getValue() == items.data.id){
					datainCombo = true;
					return false
				}
			});
			if(datainCombo){
				var urlOpts = {
					act: 'set_transcode',	
					transcode: transcodeData,
					bind_interface: tabPanel.items.items[1].items.items[0].items.items[0].getValue()
				};	
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						setTimeout(function () {
							page.win.el.unmask();
							info.applyChanged();	// applyChanged, applyNotChanged, resetDisplay
						}, 1000);
						//page.win.el.unmask();
					},
					failure: function (json, opts) {
						//transcodingPanel.el.unmask();
						AS.ARC.util.showMsgWindow({
							5401:_S('UPNP','ERROR_UNABLE_APPLY')
						}, json, page.win);
					}
				});
			}else{
				var winConfirm = new AS.ARC.msgWindow({
					parentWin: page.win,
					title: _S('COMMON', 'CONFIRMATION'),
					width: 400,
					iconType: 'question',
					asItems: [{
						xtype: 'displayfield',
						value: _S('ERROR', 'UNABLE_GET_NETWORK_INFO')
					}],
					fbar: [ {
						text: _S('COMMON', 'OK'),
						handler: function () {
							winConfirm.close();
						},
						scope: this
					}]
				});
				winConfirm.show();
			}
			
			
			
		};
		//edit function
		var editoverlap = '';
		var editfunction = function(){
			page.win.el.mask(_S('COMMON', 'LOADING'));
			var urlOpts = {
				act: 'edit',	
				name:createname,
				new_name:editname.getValue(),
				path:editvolumepath,
				overlap:editoverlap
			};	
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						reloadflag = true;
						//reloadGridStore();
						
						sharingStore.load();
						setTimeout(function () {
						page.win.el.unmask();
						}, 500);
					},
					failure: function (json, opts) {
						AS.ARC.util.showMsgWindow({
							5008: _S('UPNP', 'ERROR_NAME_EXIST'),
							5031: _S('UPNP', 'ERROR_NAME_RESERVED'),
							5019: _S('UPNP', 'ERROR_CHANG_PATH'),
							5401: _S('UPNP', 'ERROR_UNABLE_EDIT'),
							5051: _S('UPNP', 'ADD_EDIT_READ_ONLY')
						}, json, tabPanel);
					}
				});
				editwin.close();
		};
		
		//Remove cgi
		var remove = function(){
			var selected = sharegridpanel.getSelectionModel().getSelection();
			listname = selected[0].data.name;
			page.win.el.mask(_S('COMMON', 'LOADING'));
			var urlOpts = {
				act: 'remove',	
				name: listname	
			};		
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					reloadflag = true;
					//reloadGridStore();
					
					sharingStore.load();
					setTimeout(function () {
						page.win.el.unmask();
					}, 500);
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
					5401:_S('UPNP', 'ERROR_UNABLE_REMOVE')
					}, json, tabPanel);
				}
			});
			
		};
		//rename
		var rename = function(){
			page.btnOK = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'OK'),
				disabled: true,
				minWidth: 75,
				handler: function() {
					var urlOpts = {
						act: 'set',		
						server_name: ReServerName.getValue()
						
					};	
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							tab_share_show();
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5401:_S('UPNP','ERROR_UNABLE_APPLY')
							}, json, renamewin);
						}
					});
					renamewin.close();
				}
			});
			var ReServerName = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('UPNP','SERVER_NAME'),
				labelWidth: 200,
				maxLength : 32,
				allowBlank:false,
				blankText: _S('MESSAGE', 'HF00011'),
				maxLengthText : Ext.String.format(_S('UPNP', 'HF00016'), 32),
				margin: '10 0 0 0',
				listeners: {
					afterrender: function (textfield){
						var serverName = tabPanel.items.items[0].items.items[0].items.items[1].items.items[0];
						textfield.setValue(serverName.getValue());
						textfield.focus(true,10);
						if(textfield.getValue().length > 32 || textfield.getValue().length <= 0){
							page.btnOK.disable();
						}else{
							page.btnOK.enable();
						}
					},
					change: function(text){
						if(text.getValue().length > 32 || text.getValue().length <= 0){
							page.btnOK.disable();
						}else{
							page.btnOK.enable();
						}
					}
				}
			});
			var renamewin = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON','RENAME'),
				width: 450,
				height: 220,
				layout:'fit',
				parentWin: page.win,
				fbar:[
					page.btnOK,
					{
                        xtype: 'button',
                        text: _S('COMMON', 'CANCEL'),	
						handler: function() {
							renamewin.close();
						}
                    }
				],
				items:[
					{
						xtype: 'asPanelTop10',
						id:'renamewinpanel',
						items:[
							ReServerName
						]
					}
				]
			})
			renamewin.show()
		};
		
		//scan
		var scan_now = function(){
			var urlOpts = {
				act: 'scan'						
			};	
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(page.upnpUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					tab_share_show();
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
						5401: _S('UPNP', 'ERROR_UNABLE_RESCAN')
					}, json, tabPanel);
				}
			});
		}
		//function
		var folderLocation;
		var upnpname;
		var volumepath ;
		var fs;
		var createWin = function(){
			AS.ARC.upnpServer.checkUpnpType = 'create';
			overlap = '';
			var createOkBtn =  Ext.create('Ext.Button', {
			 text: _S('COMMON', 'OK'),	
				handler: function() {
					volumepath = fs.volumePath;
					if(AS.ARC.upnpServer.pathtotal ==0){
						createfunction();
						createwin.close();
						page.win.el.mask(_S('COMMON', 'LOADING'));
					}else{
						var infomsg = '';
						//var overlap = '';
						for(var i =0;i<AS.ARC.upnpServer.pathdata.length;i++){
							infomsg = infomsg +AS.ARC.upnpServer.pathdata[i].name +', ';
							overlap = overlap + AS.ARC.upnpServer.pathdata[i].name + '/';
						}
						createwin.close();
						var win = new AS.ARC.msgWindow({
							title: _S('UPNP','MEDIA_SOURCE'),
							width: 400,
							height: 200,
							parentWin: page.win,
							scope: this,
							iconType: 'question',	
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {
										createfunction();
										win.close();
										page.win.el.mask(_S('COMMON', 'LOADING'));	
									}
								},
								{
									text: _S('COMMON', 'CANCEL'),
									handler: function () {
										win.close();
									}
								}
							],
							asItems: [{
								xtype: 'displayfield',
								//value: ' If you choose this path as new share folder, the share folders '+ infomsg + ' which are included in the selected path will be merged into the new share folder. Are you sure you want to do this?'					
								value: Ext.String.format(_S('UPNP', 'INCLUDER_IN_SELECTED_PATH'), infomsg)			
							}]		
						})
						win.show();
					}
					//
					
					
				}
			});
			var cancelBtn =  Ext.create('Ext.Button', {
				text: _S('COMMON', 'CANCEL'),	
				handler: function() {
					createwin.close();
				}
			});
			
			var browseBtn = Ext.create('Ext.Button', {
				text: _S('COMMON','BROWSE'),
				//width : 100,
				// flex: 1,
				margin: '0 0 0 5',
				 handler: function () {
					AS.ARC.upnpServer.checkUpnpType = 'create';
					fs = Ext.create('AS.ARC.treeSelector', {
						parentWin: createwin,
						objectPath: folderLocation
					});
						fs.win.show();
				},
				scope: this
			});
			folderLocation = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('COMMON','PATH'),
				labelWidth: 150,
				vtype:'upnpPath',
				msgTarget: AS.ARC.config.msgTarget,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011'),	
				readOnly: true,
				listeners: {      
					change: function(text){
						if (folderLocation.isValid() == true) {
							if(upnpname.isValid() == true){
								createOkBtn.enable();
							}else{
								createOkBtn.disable();
							}
						} else {
							createOkBtn.disable();
						}
					},
					validitychange: function(text, isValid, eOpts ) {

					}
				}
			});
			 upnpname = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('COMMON','NAME'),
				id:'upnp_name',
				labelWidth: 150,
				vtype:'upnpName',
				maxLength:32,
				maxLengthText : Ext.String.format(_S('UPNP', 'HF00016'), 32),
				msgTarget: AS.ARC.config.msgTarget,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011'),	
				margin: '15 0 0 10',
				listeners: {  
					change: function(){
						if (upnpname.isValid() == true) {
							if(folderLocation.isValid() == true){
								createOkBtn.enable();
							}else{
								createOkBtn.disable();
							}
						} else {
							createOkBtn.disable();
						}
					},
					validitychange: function( field, isValid, eOpts ) {
					}	
				}
			});

			var createwin = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'ADD'),
				width: 480,
				parentWin:page.win,
				height: 250,
				layout:'fit',
				fbar:[
					createOkBtn,
					cancelBtn
				],
				items:[
					{
                    xtype: 'asPanelTop10',
					id:'createwinpanel',
					buttonApply:createOkBtn,
					items:[
						upnpname,
						{
							xtype: 'container',
							width: 430,
							margin: '10 0 0 10',
							layout: {
								//align: 'stretch',
								type: 'hbox'
							},
							items: [
									folderLocation,
									browseBtn
							]
							
						}
					],
					listeners: {
						afterrender: function (textfield) {
							upnpname.focus(true,100)
						}
					}
				   }
				]
			});
			createwin.show();
		};
		var editname ;
		var editfolderLocation;
		var editwin;
		var editfs;
		var editWin = function(){
			AS.ARC.upnpServer.checkUpnpType = 'edit';
			getvalue();
			var selected = sharegridpanel.getSelectionModel().getSelection();
			editname = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('COMMON','NAME'),
				labelWidth: 150,
				margin: '15 0 0 10',
				vtype:'upnpName',
				maxLength:32,
				value:selected[0].data.name,
				maxLengthText : Ext.String.format(_S('UPNP', 'HF00016'), 32),
				msgTarget: AS.ARC.config.msgTarget,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011'),
				listeners: {      
					change: function( field) {
						if(editname.isValid() == true){
							if(editfolderLocation.isValid() == true){
								editokBtn.enable();
							}else{
								editokBtn.disable();
							}
						}else{
							editokBtn.disable();
						}
					}	
				}
			});
			editfolderLocation = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('COMMON','PATH'),
				labelWidth: 150,
				vtype: 'upnpPath',
				readOnly: true,
				msgTarget: AS.ARC.config.msgTarget,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011'),
				value:selected[0].data.path,
				listeners: {      
					change: function( field) {
						if(editfolderLocation.isValid() == true){
							if(editname.isValid() == true){
								editokBtn.enable();
							}else{
								editokBtn.disable();
							}
						}else{
							editokBtn.disable();
						}
					},
					validitychange: function( field, isValid, eOpts ) {
				
					}	
				}
			});
			var editokBtn =  Ext.create('Ext.Button', {
				text: _S('COMMON', 'OK'),	
				handler: function() {
					editvolumepath = AS.ARC.upnpServer.upnp_path;
					
					if(path != editfolderLocation.getValue()){
						editvolumepath = editfs.volumePath;
						AS.ARC.upnpServer.upnp_newpath = editfs.volumePath;
					}
					if(AS.ARC.upnpServer.pathtotal ==0){
						editwin.close();
						editfunction();
					}else{
						var infomsg = '';
						for(var i =0;i<AS.ARC.upnpServer.pathdata.length;i++){
							infomsg = infomsg +AS.ARC.upnpServer.pathdata[i].name +', ';
							editoverlap = editoverlap + AS.ARC.upnpServer.pathdata[i].name + '/';
						}
						editwin.close();
						var win = new AS.ARC.msgWindow({
							title: _S('UPNP','MEDIA_SOURCE'),
							width: 400,
							height: 200,
							parentWin: page.win,
							scope: this,
							iconType: 'question',	
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {		
										win.close();	
										editfunction();
									}
								},
								{
									text: _S('COMMON', 'CANCEL'),
									handler: function () {
										win.close();
									}
								}
							],
							asItems: [{
								xtype: 'displayfield',
								//value: ' If you choose this path as new share folder, the share folders '+ infomsg + ' which are included in the selected path will be merged into the new share folder. Are you sure you want to do this?'					
								value: Ext.String.format(_S('UPNP', 'INCLUDER_IN_SELECTED_PATH'), infomsg)
						
						}]		
						})
						win.show();
					}
					
				}
			});
			var cancelBtn =  Ext.create('Ext.Button', {
				text: _S('COMMON', 'CANCEL'),	
				handler: function() {
					editwin.close();
				}
			});
			var browseBtn = Ext.create('Ext.Button', {
				text: _S('COMMON','BROWSE'),
				//width : 100,
				// flex: 1,
				margin: '0 0 0 5',
				 handler: function () {
					AS.ARC.upnpServer.checkUpnpType = 'edit';
					editfs = Ext.create('AS.ARC.treeSelector', {
						parentWin: editwin,
						objectPath: editfolderLocation
					});
						
						editfs.win.show();
				},
				scope: this
			});
			
			editwin = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'EDIT'),
				width: 480,
				parentWin:page.win,
				height: 250,
				layout:'fit',
				fbar:[
					editokBtn,
					cancelBtn
				],
				items:[
					{
                    xtype: 'asPanelTop10',
					buttonApply:editokBtn,
					items:[
						editname,
						{
							xtype: 'container',
							margin: '10 0 0 10',
							layout: {
								type: 'hbox'
							},
							items: [
									editfolderLocation,
									browseBtn
							]
							
						}
					]
				   }
				]
			});
			editwin.show();
		};		
		var transcodeData;
		var transcodingWin = function(){
			transcodeData =0;
			var Flac = '0x00000001';
			var Vorbis ='0x00000002';
			if(audioCheckbox.getValue()){
				transcodeData = AS.ARC.util.xorfunction('OR' ,transcodeData , Flac);
			}else{
			
			}
			if(pictureCheckbox.getValue()){
				transcodeData = AS.ARC.util.xorfunction('OR' , transcodeData , Vorbis);
			}else{
			
			}
			applyTranscode();

		};	
		//btn	
		var createBtn = Ext.create('Ext.Button', {
			text: _S('COMMON','ADD'),
			//width : 65,
			 handler: createWin
			 //scope: this
		});
		
		var editBtn = Ext.create('Ext.Button', {
			text: _S('COMMON','EDIT'),
			//width : 65,
			 disabled: true,
			 margin: '0 0 0 10',
			 handler: editWin
							
		});

		
		var removeBtn = Ext.create('Ext.Button', {
			text: _S('COMMON','REMOVE'),
			//width : 65,
			margin: '0 0 0 10',
			disabled: true,
			handler:function () {
				remove();
			}
		});
		
		var transodingApplyBtn = Ext.create('Ext.Button', {
			text: _S('COMMON','APPLY'),
			//width : 100,
			 //margin: '20 0 0 0',
			handler: transcodingWin
		});

		//gridpanel 
		
		//var shareStore = reloadGridStore();
		var sharegridpanel = Ext.create('Ext.grid.Panel',{
			itemId: 'generalGrid',
			height: 210,
			style: {
				border: '#BBB 1px solid',
				padding: 0
			},
			store: sharingStore,
			scroll: false,
			viewConfig: {
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			columns: [
				{ header: _S('COMMON','NAME'),  dataIndex: 'name' ,width: 200, sortable:false},
				{ header: _S('COMMON','PATH'),dataIndex: 'path', flex: 1, sortable:false }
			],
			bbar: Ext.create('AS.ARC.pagingToolbar', {
				border:false,
				store: sharingStore
			}),
			listeners: {
				itemclick: function( view, record, item, index, e, eOpts ) {
					if(sharegridpanel.getSelectionModel().getSelection().length > 0){
						editBtn.enable();
						removeBtn.enable();
					}else{
						editBtn.disable();
						removeBtn.disable();
					}
				}
			}
		});
		//tabpanel
		var checkGroup = Ext.create('Ext.selection.CheckboxModel');
		var transcodingStore =Ext.create('Ext.data.Store',{
			fields:['format'],
			data:[
				{format:'Flac'},
				{format:'Vorbis'}
			]
		});
		var transcodingPanel = Ext.create('Ext.grid.GridPanel', {
			selModel: checkGroup,
			autoScroll: true,
			store: transcodingStore,
			border:false,
			title: '',
			columns: [
				{
					xtype: 'gridcolumn',
					width: 450,
					dataIndex: 'format',
					text: _S('UPNP','TRANSCODING_FORMAT'),
					flex:1
				}
			]
		});
		var pictureCheckbox = Ext.create('Ext.form.field.Checkbox', {
			xtype: 'checkbox',
			itemId: 'picture',
			boxLabel: _S('UPNP', 'PICTURE'),
			handler: function (checkbox) {
			}
		});
		var audioCheckbox = Ext.create('Ext.form.field.Checkbox', {
			xtype: 'checkbox',
			itemId: 'audio',
			boxLabel: _S('UPNP', 'AUDIO'),
			handler: function (checkbox) {
			}
		});
		var tabPanel =Ext.create('Ext.TabPanel', {
			activeTab: 0,
			height: '100%',
			items: [{
				title: _S('COMMON','GENERAL'),
				height: '100%',
				itemId:'general',
				items: [{
					xtype: 'fieldset',
					margin: '15 15 15 15',
					title: AS.ARC.util.fontToBold(_S('UPNP','INFORMATION')),
					items:[{
						xtype: 'displayfield',
						fieldLabel: '<b>' +_S('COMMON','STATUS')+ '</b>',
						labelWidth:AS.ARC.config.layout.labelWidthSmall,
						width:500
					},{
						xtype: 'panel',
						layout: 'hbox',
						border: 0,
						items: [{
							xtype: 'displayfield',
							fieldLabel: '<b>' +_S('UPNP','SERVER_NAME') + '</b>',
							labelWidth:AS.ARC.config.layout.labelWidthSmall,
							width:500,
							fieldStyle:'overflow: hidden; text-overflow: ellipsis; white-space: nowrap; width: inherit;'
						},{
							xtype: 'button',
							text: _S('COMMON','RENAME'),
							handler :function () {
								rename();
							}
						}]
					},{
						xtype: 'panel',
						layout: 'hbox',
						border: 0,
						items: [{
							xtype: 'displayfield',
							fieldLabel: '<b>' +_S('UPNP','LAST_SCANNING_DATE')+'</b>' ,
							labelWidth:AS.ARC.config.layout.labelWidthSmall,
							width:500,
							fieldStyle:'overflow: hidden; text-overflow: ellipsis; white-space: nowrap; width: inherit;'
						},{
							xtype: 'button',
							text: _S('UPNP','SCAN_NOW'),
							handler :function () {
								scan_now();
							}
						}]
					},{
						xtype: 'displayfield',
						fieldLabel: '<b>' +_S('UPNP','INTERFACE')+ '</b>',
						labelWidth:AS.ARC.config.layout.labelWidthSmall,
						width:500
					}]
				},{
					xtype: 'fieldset',
					margin: '15 15 15 15',
					title: AS.ARC.util.fontToBold(_S('UPNP','MEDIA_SOURCE')),
					items:[
						createBtn,
						editBtn,
						removeBtn,
						sharegridpanel
					]
				}],
				listeners: {
					render:function(){
						tab_share_show();
					}
				}
			},{
				title: _S('COMMON','ADVANCED'),
				height: '100%',
				itemId:'advance',
				cls: 'upnp-v1-tab-advanced',
				items:[{
					xtype: 'fieldset',
					margin: '15 15 15 15',
					title: AS.ARC.util.fontToBold(_S('COMMON','ADVANCED')),
					items:[
						// append a Ext.form.field.ComboBox, name: interfaceCombo
					]
				},{
					xtype: 'fieldset',
					margin: '15 15 15 15',
					title: AS.ARC.util.fontToBold(_S('UPNP','TRANSCODING')),
					items:[{
						xtype: 'displayfield',
						value: _S('UPNP', 'TRANSCODING_MSG')
					},			
					audioCheckbox,
					pictureCheckbox
						
					]
				}/*,{
					layout: 'hbox',
					border: 0,
					margin:'15 5 0 0',
					items: [{
						xtype: 'tbfill'
					},
					transodingApplyBtn]
					
				}*/],
				fbar: [{
                    xtype: 'asupnpServerChangeInfo',
                    itemId: 'info'
                }, {
					xtype:'tbfill'
				},
				{
                    xtype: 'button',
                    itemId: 'apply',
                    text: _S('COMMON', 'APPLY'),
                    listeners: {
						click: function(){
							transcodingWin();
						}
					}
                }
			],
				
			}],
			listeners: {
				tabchange: function (tabPanel, newCard, oldCard, eOpts) {
					if (newCard.itemId == 'general') {
						tab_share_show();
					} else if (newCard.itemId == 'advance') {
						tab_preference_show();						
					}
					Ps.update(tabPanel.body.dom);
				},
				resize: function(tabPanel){

					mainTabPanelHeight = tabPanel.getHeight() - 40;
					mainTabPanelWidth = tabPanel.getWidth();
					// tabPanel.items.get('general').setHeight(mainTabPanelHeight);
					// tabPanel.items.get('general').setWidth(mainTabPanelWidth);
					// tabPanel.items.get('advance').setHeight(mainTabPanelHeight);
					// tabPanel.items.get('advance').setWidth(mainTabPanelWidth);

					if (tabPanel.getActiveTab().itemId === 'general') {
						var gridH = mainTabPanelHeight - 350;
						var gridW = tabPanel.getActiveTab().items.items[1].getWidth() - 30;
						// (gridH < 220) ? gridH=180 : gridH=gridH; 
						// tabPanel.down('[itemId=generalGrid]').setHeight(gridH);
						// tabPanel.down('[itemId=generalGrid]').setWidth(gridW);

						fsetW = mainTabPanelWidth - 40;
						tabPanel.getActiveTab().items.items[0].setWidth(fsetW);
						tabPanel.getActiveTab().items.items[1].setWidth(fsetW);
					}

					tabPanel.items.items[0].doLayout();
					tabPanel.items.items[1].doLayout();
					Ps.update(tabPanel.body.dom);
				}
			}
		});		
		this.win = this.desktop.createWindow({		
			app: this.app,
			id: this.id,
			itemId: this.id,
			title: 'upnpServer',						
			width: 880,
			height: 550,
			// minWidth: 880,
			// minHeight: 550,
			resizable: true,
			maximizable: true, 
			border: false,
			layout: 'border',
            items: [{
				xtype: 'panel',
				height: '100%',
				region: 'center',
				border: false,
				items: [
					tabPanel
				]
            }],
            checkReadOnly: function () {
            	var me = this,
            		upnpUrl = AS.ARC.util.getUserAppsPath() + 'upnp-server/' + 'upnpsrv.cgi';
            	AS.ARC.ajax({
            		url: AS.ARC.util.getApiUrlWithSid(upnpUrl, { act: 'check_volume' }),
            		method: 'post',
            		success: function (json, opts) {

            			
            		},
            		failure: function (json, opts) {
            			
            			var cb = function (){
            				if (json.error_code === 5051) {
            					me.close();
            				}
            			}
            			
            			AS.ARC.util.showMsgWindow({
            				5051: _S('ERROR', 'SYSTEM_READ_ONLY')
            			}, json, me, 'warning', cb);
            		}
            	});
            },
			listeners: {
				afterrender: function (win){
					win.header.items.items[1].hide();
					win.checkReadOnly();
				},
				beforeshow: function(){
					overlap = ''
				}
			}
			
		});
	},
    getDisplayDateTime: function (options) {
        var options = options || {},
            dateFormat = options.dateFormat,
            timeFormat = options.timeFormat,
            year = options.year,
            month = options.month,
            day = options.day,
            hour = options.hour,
            minute = options.minute,
            second = options.second,
            ampm = '',
            format = '';
        
        switch (dateFormat) {
            case 0:
                format = year + '/' + month + '/' + day;
                break;
            case 1:
                format = year + '-' + month + '-' + day;
                break;
            case 2:
                format = year + '.' + month + '.' + day;
                break;
            case 3:
                format = month + '/' + day + '/' + year;
                break;
            case 4:
                format = month + '-' + day + '-' + year;
                break;
            case 5:
                format = month + '.' + day + '.' + year;
                break;
            case 6:
                format = day + '/' + month + '/' + year;
                break;
            case 7:
                format = day + '-' + month + '-' + year;
                break;
            case 8:
                format = day + '.' + month + '.' + year;
                break;
            default:
                format = '';
        }

        switch (timeFormat) {
            case 0: //12
                if (hour >= 12) {
                    ampm = 'PM';
                    if (hour != 12) {
                        hour = hour - 12;
                    }
                } else {
                    ampm = 'AM';
                    if (hour == 0) {
                        hour = 12;
                    }
                }
                format += ' ' + ampm + ' ' + AS.util.string.fill(hour) + ':' + AS.util.string.fill(minute);

                if (typeof second !== 'undefined') {
                    format += ':' + AS.util.string.fill(second);
                }
                break;
            case 1: //24
                format += ' ' + AS.util.string.fill(hour) + ':' + AS.util.string.fill(minute)
                
                if (typeof second !== 'undefined') {
                    format += ':' + AS.util.string.fill(second);
                }
                break;
            default:
                format = '';
        }
        
        return format;
    }
});

/**
 * @class AS.ARC.apps.upnpServer.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('AS.ARC.apps.upnpServer.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'upnp-server',
	title: 'upnpServer',
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],
	
	createWindow: function () {
		var desktop = this.core.getDesktop(),			
			app = this;
			
		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}
		
		// Set appIsReady to false
		this.appIsReady = false;

		var newDC = new AS.ARC.apps.upnpServer.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
		});

		newDC.win.on('render', function () {
			app.appOpenNum++;
			app.appIsReady = true;
			app.appWins.pop();
		});		
		
		newDC.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
		});		
		
		newDC.win.show();
		// Get all wins for handling
		this.appWins.push(newDC.win);
	}
});

